--------------------------------
-- Coded by: Exzu / EU-Aszune --
--------------------------------
--     MAINFRAME & SCANNER    --
--------------------------------
SS_Spacer = "Interface\\Addons\\SatchelScanner\\textures\\hr.tga";
SS_Border = "Interface\\Addons\\SatchelScanner\\textures\\border.tga";
SS_BagIcon = "Interface\\Addons\\SatchelScanner\\textures\\bagIcon.tga";
SS_TankIcon = "Interface\\Addons\\SatchelScanner\\textures\\tankIcon.tga";
SS_HealerIcon = "Interface\\Addons\\SatchelScanner\\textures\\healerIcon.tga";
SS_DpsIcon = "Interface\\Addons\\SatchelScanner\\textures\\dpsIcon.tga";
SS_StartButton = "Interface\\Buttons\\UI-Panel-Button-Up.blp";
SS_StopButton = "Interface\\Buttons\\UI-Panel-Button-Up.blp";
SS_ConfigButton = "Interface\\Addons\\SatchelScanner\\icons\\config.tga";
SS_CloseButton = "Interface\\Addons\\SatchelScanner\\icons\\close.tga";

SS_instanceID1 = 1046; -- Heroics
SS_instanceID2 = 0; -- Mythic Dungeon
SS_instanceID3 = 995; -- Timewalking
SS_instanceID4 = 1287; -- Darkbough
SS_instanceID5 = 1188; -- Tormented Guardians
SS_instanceID6 = 1289; -- Rift of Aln
SS_instanceID7 = 1411; -- Trial of Valor
SS_instanceID8 = 1290; -- Arcing Aqueducts
SS_instanceID9 = 1291; -- Royal Athenaeum
SS_instanceID10 = 1292; -- Nightspire
SS_instanceID11 = 1293; -- Betrayer's Rise


SS_masterFrameTable = {
	[1] = {
		[1] = { x = 5, texture = SS_TankIcon, },
		[2] = { x = 22, color = {1, 1, 1, 1}, text = "Tank:", },
		[3] = { x = 50, color = {1, 0, 0, 1}, text = "Not Scanning...", },
		[4] = { enabled = "SS_heroicDungeonBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID1},
		[5] = { enabled = "SS_mythicDungeonBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID2},
		[6] = { enabled = "SS_timewalkingDungeonBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID3},
		[7] = { enabled = "SS_DarkboughBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID4},
		[8] = { enabled = "SS_TormentedGuardiansBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID5},
		[9] = { enabled = "SS_RiftofAlnBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID6},
		[10] = { enabled = "SS_TrialofValorBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID7},
		[11] = { enabled = "SS_ArcingAqueductsBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID8},
		[12] = { enabled = "SS_RoyalAthenaeumBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID9},
		[13] = { enabled = "SS_NightspireBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID10},
		[14] = { enabled = "SS_BetrayersRiseBox1", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID11},
	},
	[2] = {
		[1] = { x = 5, texture = SS_HealerIcon, },
		[2] = { x = 22, color = {1, 1, 1, 1}, text = "Heal:", },
		[3] = { x = 49, color = {1, 0, 0, 1}, text = "Not Scanning...", },
		[4] = { enabled = "SS_heroicDungeonBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID1},
		[5] = { enabled = "SS_mythicDungeonBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID2},
		[6] = { enabled = "SS_timewalkingDungeonBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID3},
		[7] = { enabled = "SS_DarkboughBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID4},
		[8] = { enabled = "SS_TormentedGuardiansBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID5},
		[9] = { enabled = "SS_RiftofAlnBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID6},
		[10] = { enabled = "SS_TrialofValorBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID7},
		[11] = { enabled = "SS_ArcingAqueductsBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID8},
		[12] = { enabled = "SS_RoyalAthenaeumBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID9},
		[13] = { enabled = "SS_NightspireBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID10},
		[14] = { enabled = "SS_BetrayersRiseBox2", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID11},
	},
	[3] = {
		[1] = { x = 5, texture = SS_DpsIcon, },
		[2] = { x = 22, color = {1, 1, 1, 1}, text = "DPS:", },
		[3] = { x = 46, color = {1, 0, 0, 1}, text = "Not Scanning...", },
		[4] = { enabled = "SS_heroicDungeonBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID1},
		[5] = { enabled = "SS_mythicDungeonBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID2},
		[6] = { enabled = "SS_timewalkingDungeonBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID3},
		[7] = { enabled = "SS_DarkboughBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID4},
		[8] = { enabled = "SS_TormentedGuardiansBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID5},
		[9] = { enabled = "SS_RiftofAlnBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID6},
		[10] = { enabled = "SS_TrialofValorBox3", x = 5, color = {255, 255, 255, 1}, text = "# ...", id = SS_instanceID7},
		[11] = { enabled = "SS_ArcingAqueductsBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID8},
		[12] = { enabled = "SS_RoyalAthenaeumBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID9},
		[13] = { enabled = "SS_NightspireBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID10},
		[14] = { enabled = "SS_BetrayersRiseBox3", x = 5, color = {1, 1, 1, 1}, text = "# ...", id = SS_instanceID11},
	},
};

SS_slimFrame = {
	SS_HeaderText = { loc = "TOP", x = 0, y = 8, fontSize = "14", color = {1, 1, 1, 1}, text = "Satchel Scanner", },
	SS_SubHeaderText = { loc = "TOPLEFT", x = 5, y = -5, fontSize = "16", color = {0, 1, 0, 1}, text = "Current Status:", },
	SS_SubHeaderText2 = { loc = "TOPLEFT", x = 95, y = -5, fontSize = "16", color = {1, 0, 0, 1}, text = "Not Running", },
	SS_configButton = { loc = "TOP", x = 97, y = -5, width = "16", height = "16", functionName = "InterfaceOptionsFrame_OpenToCategory(SS_Options.childpanel)", texture = SS_ConfigButton, pushedTxt = "Interface\\Addons\\SatchelScanner\\icons\\configpush.tga", highLightTxt = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp", },
	SS_closeButton = { loc = "TOP", x = 115, y = -5, width = "16", height = "16", functionName = "hideMainFrame()", texture = SS_CloseButton, pushedTxt = "Interface\\Addons\\SatchelScanner\\icons\\closepush.tga", highLightTxt = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp", },
	SS_HeaderSpacertexture = { loc = "TOP", x = 0, y = -23, width = "0" , height = "2", texture = SS_Spacer},
	SS_bagIcontexture = { loc = "TOP", x = 79, y = -5, width = "16", height = "16", texture = SS_BagIcon, },
	SS_bagCounterText = { loc = "TOP", x = 65, y = -7, fontSize = "14", color = {0, 0.6, 0.8, 1}, text = "0", },
	SS_startButton = { loc = "BOTTOM", x = -85, y = 5, text = "Start", yscale = 22/32, xscale = 80/130, width = "80", height = "25", functionName = "startScanning()", texture = SS_StartButton, pushedTxt = "Interface\\Buttons\\UI-Panel-Button-Down.blp", highLightTxt = "Interface\\Buttons\\UI-Panel-Button-Highlight.png", },
	SS_stopButton = { loc = "BOTTOM", x = 85, y = 5, text = "Stop", yscale = 22/32, xscale = 80/130, width = "80", height = "25", functionName = "stopScanning()", texture = SS_StopButton, pushedTxt = "Interface\\Buttons\\UI-Panel-Button-Down.blp", highLightTxt = "Interface\\Buttons\\UI-Panel-Button-Highlight.png", },
};

--for i = 1, GetNumRFDungeons() do
--  local id, name = GetRFDungeonInfo(i)
--  print(id .. ": " .. name)
--end
--for i = 1, GetNumRandomDungeons() do
--  local id, name = GetLFGRandomDungeonInfo(i)
--  print(id .. ": " .. name)
--end

-- Variables
local running = false; -- Boolean to detect Running/paused state
SS_addonVersion = 7.12; -- Addon Version, useful for wiping savedvariables if needed
SS_versionTag = "Release";

local tankSatchelFound = false; -- Specific Boolean for Tank Satchels
local healSatchelFound = false; -- Specific Boolean for Healer Satchels
local dpsSatchelFound = false; -- Specific Boolean for DPS Satchels

-- Dungeon Scan Var
SS_runVar = {"Not Running", "Running"};
SS_scanVar = {"#", "# ...", "# Searching...","# Legion Heroic!", "# Legion Mythic!", "# Timewalking Dungeon!","# Darkbough!","# Tormented Guardians!","# Rift of Aln!","# Trial of Valor!","# Arcing Aqueducts!","# Royal Athenaeum!","# Nightspire!","# Betrayer's Rise!"}
SS_classScan = {"Not Scanning...","Scanning...","Satchel Found!"};
SS_ctaVar = {"Call to Arms: Tank","Call to Arms: Healer","Call to Arms: Dps"};



-- Text Colors
local redColor = {1,0,0,1};
local greenColor = {0,1,0,1};
local yellowColor = {1,1,0,1};
local whiteColor = {1,1,1,1};

function updateFrames()
	local yvar = -30;
	if not _G["SS_InstanceText3#14"] and not running then
		for j, var in ipairs(SS_masterFrameTable) do -- This is for drawing each texture
			for i, tVar in ipairs(var) do
				if not (i == 1) and not _G["SS_InstanceText"..j.."#"..i] then
					_G["SS_InstanceText"..j.."#"..i] = SatchelDisplayFrame:CreateFontString(nil, "OVERLAY")
					_G["SS_InstanceText"..j.."#"..i]:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
					_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(tVar.color));
					_G["SS_InstanceText"..j.."#"..i]:SetText(tVar.text);
					_G["SS_InstanceText"..j.."#"..i]:SetPoint("TOPLEFT", 0, 0);
					_G["SS_InstanceText"..j.."#"..i]:Hide();
				elseif (i == 1) and not _G["SS_InstanceIcon"..j.."#"..i] then
					_G["SS_InstanceIcon"..j.."#"..i] = CreateFrame("Button", nil, SatchelDisplayFrame);
					_G["SS_InstanceIcon"..j.."#"..i]:SetWidth("16");
					_G["SS_InstanceIcon"..j.."#"..i]:SetHeight("16");
					_G["SS_InstanceIcon"..j.."#"..i]:SetNormalTexture(tVar.texture)
					_G["SS_InstanceIcon"..j.."#"..i]:SetPoint("TOPLEFT", 0, 0);
					_G["SS_InstanceIcon"..j.."#"..i]:Hide();
				end	
			end
		end
	end
	if _G["SS_InstanceText3#14"] and not running then
		for j, var in ipairs(SS_masterFrameTable) do -- This is for displaying/hiding each texture
			for i, tVar in ipairs(var) do
				if tVar.enabled then
					if (_G[tVar.enabled]:GetChecked()) then
						_G["SS_InstanceText"..j.."#"..i]:SetPoint("TOPLEFT", tVar.x, yvar);
						_G["SS_InstanceText"..j.."#"..i]:SetText(tVar.text);
						_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(tVar.color));
						_G["SS_InstanceText"..j.."#"..i]:Show();
						yvar = yvar - 15;
						local heigth = (yvar*-1) + 30;
						SatchelDisplayFrame:SetHeight(heigth);
					elseif not (_G[tVar.enabled]:GetChecked()) then
						_G["SS_InstanceText"..j.."#"..i]:Hide();
					end
				elseif _G["SS_InstanceText"..j.."#"..i] and not tVar.enabled then
					_G["SS_InstanceText"..j.."#"..i]:SetPoint("TOPLEFT", tVar.x, yvar);
					_G["SS_InstanceText"..j.."#"..i]:SetText(tVar.text);
					_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(tVar.color));
					_G["SS_InstanceText"..j.."#"..i]:Show();
					if not (i < 3) then
						yvar = yvar - 17;
					end
				elseif (i == 1) and _G["SS_InstanceIcon"..j.."#"..i] then
					_G["SS_InstanceIcon"..j.."#"..i]:SetPoint("TOPLEFT", tVar.x, yvar);
					_G["SS_InstanceIcon"..j.."#"..i]:Show();
					if (i == 1) then
						yvar = yvar - 1;
					end
				end
			end
		end
	end
	if _G["SS_InstanceText3#14"] and running then
		for j, var in ipairs(SS_masterFrameTable) do -- This is for setting scan parameters
			for i, tVar in ipairs(var) do
				if (i > 1) and (_G["SS_InstanceText"..j.."#"..i]:IsShown()) then
					if tVar.enabled then
						_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(whiteColor));
						_G["SS_InstanceText"..j.."#"..i]:SetText(SS_scanVar[3]);
					elseif (i == 3) then
						_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(yellowColor));
						_G["SS_InstanceText"..j.."#"..i]:SetText(SS_classScan[2]);
					end
				end
			end
		end
	end
end

function drawFrames() -- Draws the SatchelDisplayFrame --
	-- Draw Core
	SatchelDisplayFrame = CreateFrame("Frame", "SatchelFrame", UIParent)
	SatchelDisplayFrame:SetMovable(true)
	SatchelDisplayFrame:EnableMouse(true)
	SatchelDisplayFrame:SetScript("OnMouseDown", function(self, button)
		if button == "LeftButton" and not self.isMoving then
			self:StartMoving();
			self.isMoving = true;
		end
	end)
	SatchelDisplayFrame:SetScript("OnMouseUp", function(self, button)
		if button == "LeftButton" and self.isMoving then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	SatchelDisplayFrame:SetScript("OnHide", function(self)
		if ( self.isMoving ) then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	SatchelDisplayFrame:SetWidth(260);
	SatchelDisplayFrame:SetHeight(60);
	SatchelDisplayFrame:SetPoint("TOPLEFT", 200, -400);
	SatchelDisplayFrame:SetFrameStrata("BACKGROUND")
	SatchelDisplayFrame:SetBackdrop({ 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = SS_Border, tile = false, tileSize = 0, edgeSize = 8, 
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	});
	for i, tVar in pairs(SS_slimFrame) do
		if string.find(i, "Button") then
			_G[i] = CreateFrame("Button", nil, SatchelDisplayFrame, UIPanelButtonTemplate);
			_G[i]:SetWidth(tVar.width);
			_G[i]:SetHeight(tVar.height);
			_G[i]:SetPoint(tVar.loc, tVar.x, tVar.y);
			_G[i]:SetNormalTexture(tVar.texture);
			_G[i]:SetPushedTexture(tVar.pushedTxt);
			_G[i]:SetHighlightTexture(tVar.highLightTxt);
			_G[i]:SetScript("OnClick", loadstring(tVar.functionName))
			if string.find(i, "start") or string.find(i, "stop") then
				_G[i]:GetNormalTexture():SetTexCoord(0,tVar.xscale,0,tVar.yscale);
				_G[i]:GetPushedTexture():SetTexCoord(0,tVar.xscale,0,tVar.yscale);
				_G[i]:GetHighlightTexture():SetTexCoord(0,tVar.xscale,0,tVar.yscale);
				if tVar.text then
					local buttonText = _G[i]:CreateFontString(nil, "OVERLAY")
					buttonText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "");
					buttonText:SetPoint("CENTER", 0, 0);
					buttonText:SetTextColor(unpack(yellowColor));
					buttonText:SetText(tVar.text);
				end
			end
		elseif string.find(i, "texture") then
			_G[i] = CreateFrame("Button", nil, SatchelDisplayFrame);
			_G[i]:SetWidth(tVar.width);
			_G[i]:SetHeight(tVar.height);
			_G[i]:SetPoint(tVar.loc, tVar.x, tVar.y);
			_G[i]:SetNormalTexture(tVar.texture)
			if string.find(i, "Spacer") then
				_G[i]:SetWidth(SatchelDisplayFrame:GetWidth() - 14);
				_G[i]:SetAlpha(1);
			end
		elseif string.find(i, "Text") then
			_G[i] = SatchelDisplayFrame:CreateFontString(nil, "OVERLAY")
			_G[i]:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", tVar.fontSize, "OUTLINE");
			_G[i]:SetPoint(tVar.loc, tVar.x, tVar.y);
			_G[i]:SetTextColor(unpack(tVar.color));
			_G[i]:SetText(tVar.text);
		end
	end
	SS_datacall("read");
	updateFrames();
end

function startScanning()
	if not running then
		running = true
		SS_SubHeaderText2:SetText(SS_runVar[2]);
		SS_SubHeaderText2:SetTextColor(unpack(greenColor));
		updateFrames();
		RequestLFDPlayerLockInfo();
	--elseif not running and not (SS_hcDungeon1 or SS_hcDungeon2 or SS_hcDungeon3) then
	--	print("Must choose atleast one class before starting scan!");
	end
end

function stopScanning()
	if running then
		running = false;
		SS_SubHeaderText2:SetText(SS_runVar[1]);
		SS_SubHeaderText2:SetTextColor(unpack(redColor));
		tankSatchelFound = false;
		healSatchelFound = false;
		dpsSatchelFound = false;
		updateFrames();
	end
end

function hideMainFrame()
	SatchelDisplayFrame:Hide();
	showUI = false;
	SatchelScannerDB["showMainFrame"] = showUI;
end

function SS_Scanner()
	if (_G["SS_InstanceText3#14"]) and running then
		for j, var in ipairs(SS_masterFrameTable) do -- This is for drawing each texture.'
			local SatchelFound;
			for i, tVar in ipairs(var) do
				if (i > 3) then
					if (_G[tVar.enabled]:GetChecked()) then
						local eligible, forTank, forHeal, forDps = GetLFGRoleShortageRewards(tVar.id, 1)
						if forTank and (j == 1) then
							_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(greenColor));
							_G["SS_InstanceText"..j.."#"..i]:SetText(SS_scanVar[i]);
							SatchelFound = true;
						elseif not forTank and (j == 1) then
							_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(whiteColor));
							_G["SS_InstanceText"..j.."#"..i]:SetText(SS_scanVar[3]);
						end
						if forHeal and (j == 2) then
							_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(greenColor));
							_G["SS_InstanceText"..j.."#"..i]:SetText(SS_scanVar[i]);
							SatchelFound = true;
						elseif not forHeal and (j == 2) then
							_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(whiteColor));
							_G["SS_InstanceText"..j.."#"..i]:SetText(SS_scanVar[3]);
						end
						if forDps and (j == 3) then
							_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(greenColor));
							_G["SS_InstanceText"..j.."#"..i]:SetText(SS_scanVar[i]);
							SatchelFound = true;
						elseif not forDps and (j == 3) then
							_G["SS_InstanceText"..j.."#"..i]:SetTextColor(unpack(whiteColor));
							_G["SS_InstanceText"..j.."#"..i]:SetText(SS_scanVar[3]);
						end
					end
				end
			end
			if SatchelFound then
				FlashClientIcon();
				_G["SS_InstanceText"..j.."#3"]:SetText(SS_classScan[3]);
				if SS_raidWarnNotify then
					RaidNotice_AddMessage(RaidWarningFrame, SS_ctaVar[j], ChatTypeInfo["RAID_WARNING"])
				end
				if not SatchelDisplayFrame:IsShown() then
					SatchelDisplayFrame:Show();
				end
			else
				_G["SS_InstanceText"..j.."#3"]:SetText(SS_classScan[2]);
			end
		end
	end
end

-------------------------------
-- PRINT, ERROR COLLECT ETC. --
-------------------------------
function errorCollect(e, e2)
	print("|cffff0000==== SS3 ERROR DUMP ====");
	print("|cFF0080FFSS3: |cffffffffINVALID '"..e.."' CALL");
	print("|cFF0080FFSS3: |cffffffffCALL USED WAS: '"..e2.."'");
	print("|cFF0080FFSS3: |cffffffffPLEASE REPORT TO DEVELOPER");
	print("|cffff0000==== END OF SS3 DUMP ====");
end

function printm(msg)
	print("|cFFFF007F" .. msg  .. "|r");
end

----------------------------------
-- ON LOAD, ON UPDATE, ON EVENT --
----------------------------------

function SatchelScanner_OnEvent(self, event, arg, arg2)
	local SS_inLFGQueue = GetLFGQueueStats(LE_LFG_CATEGORY_LFD)
	local SS_inLFRQueue = GetLFGQueueStats(LE_LFG_CATEGORY_LFR)
	local SS_debuff = UnitDebuff("player", "Dungeon Deserter")
	local SS_inGroup = IsInGroup()
	if event == "ADDON_LOADED" and arg == "SatchelScanner" then
		SS_interfaceConfig();
		printm("Satchel Scanner v"..SS_addonVersion.."-"..SS_versionTag.." Loaded!");
		printm("->> Type /ss3 for commands!");
	elseif event == "CHAT_MSG_LOOT" and string.find(arg, "Shattered Satchel of Cooperation") and not (MailFrame:IsShown() or TradeFrame:IsShown()) then
		SS_satchelsReceived = SS_satchelsReceived + 1;
		SS_datacall("update");
		SS_bagCounterText:SetText(SS_satchelsReceived);
	elseif event == "LFG_QUEUE_STATUS_UPDATE" then
		-- This is just thrown to make sure SS_inLFGQueue/SS_inLFRQueue works as intended.
		-- Mostly to keep the booleans true/false even after an Que rejoin.
	elseif event == "PLAYER_ENTERING_WORLD" then
		ss_inInstance = IsInInstance()
	elseif event == "LFG_UPDATE_RANDOM_INFO" and running and not SS_inLFGQueue and not SS_inLFRQueue and not string.find(SS_debuff or "", "Dungeon Deserter") and (SS_scanInDungeon or not ss_inInstance) and (SS_scanInGroup or not SS_inGroup) then
		SS_Scanner();
	end
end

function SatchelScanner_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("CHAT_MSG_LOOT");
	self:RegisterEvent("LFG_UPDATE_RANDOM_INFO");
	self:RegisterEvent("LFG_QUEUE_STATUS_UPDATE");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	SLASH_SATCHELSCANNER1, SLASH_SATCHELSCANNER2 = "/satchelscan", "/ss3"
	SlashCmdList.SATCHELSCANNER = function(msg)
		if msg == "toggle" then
			if SatchelDisplayFrame:IsShown() then
				SatchelDisplayFrame:Hide();
				SS_showUI = false;
			else
				SatchelDisplayFrame:Show();
				SS_showUI = true;
			end
			SS_datacall("update");
		elseif msg == "start" then
			startScanning();
		elseif msg == "stop" then
			stopScanning();
		elseif msg == "reset" then
			SS_satchelsReceived = SatchelScannerDB["satchels"];
			SS_datacall("reset");
		elseif msg == "reset-counter" then
			SS_satchelsReceived = 0;
			SS_datacall("update");
		elseif msg == "config" then
			InterfaceOptionsFrame_OpenToCategory(SS_Options.childpanel);
		elseif msg == "faq" then
			InterfaceOptionsFrame_OpenToCategory(SS_Options.panel);
		else
			printm("====== Satchel Scanner ======");
			printm("->> Type '/ss3 toggle' to show/hide the frame");
			printm("->> Type '/ss3 start' to start scanning");
			printm("->> Type '/ss3 stop' to stop scanning");
			printm("->> Type '/ss3 reset' to reset the addon");
			printm("->> Type '/ss3 reset-counter' to reset the bag counter");
			printm("->> Type '/ss3 config' to configure the addon");
			printm("->> Type '/ss3 faq' to open the F.A.Q")
		end
		msg = ""
	end
end

function SatchelScanner_OnUpdate(self, elapsed)
	if running and not SS_inLFGQueue and not SS_inLFRQueue and (SS_scanInDungeon or not ss_inInstance) and (SS_scanInGroup or not SS_inGroup) then
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
		while (self.TimeSinceLastUpdate > SS_ScannerInterval) do
			RequestLFDPlayerLockInfo();
			if (tankSatchelFound or healSatchelFound or dpsSatchelFound) and SS_playSound and running then
				PlaySoundFile("Sound\\interface\\RaidWarning.ogg", "Master")
			end
			self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - SS_ScannerInterval;
		end
	end
end


